<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

/* 
 * ПАРАМЕТРЫ:
 * 1. value: активатор возможности модуля
 *   1. browse     - список пунктов каталога
 *   2. add        - добавление пункта
 *   3. edit       - редактирование пункта
 *   4. delete     - удаление пункта
 *   5. parent     - назначение родителя пункта
 *   6. position   - смена позиции в списке пунктов
 * 2. tree: ID узла к которому привязан каталог
 * 3. tpl: шаблон
 * 4. type: тип каталога. уникальное имя по которому система определит пункты каталога в БД
 */

class catalog extends core
{
	/*инициализация объектов для работы данного класса*/
	function catalog($value)
	{
        $this->core();

        $this->map_parent = $value['tree'];
        $this->type       = $value['type'];
	}
    	
	/* CASE : DELETE */
	
	function delete_catalog($catalog_id)
	{
		$sql = "SELECT map_id FROM rs_catalog WHERE catalog_id='".$catalog_id."'";
		
		if (!$catalog = $this->db->accept_select($sql))
			return FALSE;
		
		$sql = "DELETE FROM rs_catalog WHERE catalog_id='".$catalog_id."'";
		
		$this->db->accept_delete($sql);
		$this->sysDB->delete($catalog[0]['map_id']);
		
		$sql = "SELECT catalog_id"
			." FROM rs_catalog"
			." WHERE catalog_tree='".$this->map_parent."'"
			." ORDER BY catalog_position";
		
		if ($position = $this->db->accept_select($sql))
		{
			$new_position = 1;
			foreach ($position as $value)
			{
				$what	= array('catalog_position' => $new_position);
				$where	= 'catalog_id=\''.$value['catalog_id'].'\'';
				
				$this->db->accept_update($what, 'rs_catalog', $where);
				
				$new_position++;
			}
		}
		
		exit;
	}

	/* CASE : POSITION */
	
	function change_position($catalog_id, $step)
	{
		$sql = "SELECT catalog_position FROM rs_catalog WHERE catalog_id='".$catalog_id."'";
		
		if (!$position = $this->db->accept_select($sql))
			return FALSE;
		
		$old_position = $position[0]['catalog_position'];
			
		if ($step == 'down')
			$new_position = $position[0]['catalog_position'] + 1;
			
		if ($step == 'up')
			$new_position = $position[0]['catalog_position'] - 1;
			
		$sql = "SELECT catalog_id"
			." FROM rs_catalog"
			." WHERE catalog_position='".$new_position."'"
			." AND catalog_tree='".$this->map_parent."'";
		
		if (!$row_id = $this->db->accept_select($sql))
			return FALSE;
		
		$this->db->accept_update(array('catalog_position' => $new_position), 'rs_catalog', 'catalog_id=\''.$catalog_id.'\'');
		$this->db->accept_update(array('catalog_position' => $old_position), 'rs_catalog', 'catalog_id=\''.$row_id[0]['catalog_id'].'\'');
		
		exit;
	}

	/* CASE : PARENT */
	
	function get_parent_list($catalog_id)
	{
		$sql = "SELECT * FROM rs_catalog WHERE catalog_tree='".$this->map_parent."'";
		
		if (!$parent_list = $this->db->accept_select($sql))
			return FALSE;
		
		$sql = "SELECT catalog_parent FROM rs_catalog WHERE catalog_id='".$catalog_id."'";

		if (!$select_parent = $this->db->accept_select($sql))
			return FALSE;
		
		$result['catalog'] 		= $parent_list;
		$result['select_catalog'] 	= $catalog_id;
		$result['select_parent'] 	= $select_parent[0]['catalog_parent'];
			
		return $result;
	}
	
	function edit_parent($fields)
	{
		/* 1. выводим две строчки (редактируемый пункт и нового родителя из rs_catalog) */
		$sql = ""
			."SELECT"
			." c.catalog_id as catalog_id, c.map_id as map_id, m.map_alias as catalog_alias,"
			." c.catalog_parent as catalog_parent"
			
			." FROM rs_catalog c, rs_map m"
			
			." WHERE c.catalog_id = '".$fields['catalog_id']."'"
			." AND c.map_id=m.map_id"; //редактируемый пункт
		
		if (!$edit_item = $this->db->accept_select($sql))
			return FALSE;
		
		$edit_item = $edit_item[0];
		
		//родитель
		if ($fields['catalog_parent'] != 0)// если родитель НЕ равен нулю, то вытаскиваем инфу из rs_catalog
		{
			$sql = "SELECT * FROM rs_catalog WHERE catalog_id = '".$fields['catalog_parent']."'";
			if (!$parent_item = $this->db->accept_select($sql))
				return FALSE;
			
			$parent_item = $parent_item[0];
		}
		else// если родитель равен нулю, то определяем id корня в rs_map
			$parent_item['map_id'] = $this->map_parent;
		
		/* Редактирование */
		
		if ($edit_item['catalog_parent'] != $fields['catalog_parent'])
		{
			/* 2. отредактируем положение веток в rs_catalog */
			
			$this->db->accept_update(array('catalog_parent' => $fields['catalog_parent']), 'rs_catalog', "catalog_id='".$edit_item['catalog_id']."'");
			
			/* 3. отредактируем положение веток в rs_map */
			
			$alias = $this->sysDB->check_take_alias($edit_item['catalog_alias'], $parent_item['map_id']);

            $map_array = array(
                'map_id'            => $edit_item['map_id'],
                'map_alias'         => $alias
            );
            
            $this->sysDB->update_map($map_array);

			$this->db->accept_update(array('map_parent' => $parent_item['map_id']), 'rs_map', "map_id='".$edit_item['map_id']."'");
		}
		
		preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
		$referer = $referer[1];
		
		$this->tools->move_to($referer);
	}

	/* CASE : ADD */
	
	function add_catalog($fields)
	{
        $fields['catalog_alias'] = $this->sysDB->check_take_alias($fields['catalog_alias'], $this->map_parent);
		
		$map_array = array(
            'map_parent'    => $this->map_parent,
            'map_name'      => $fields['catalog_name'],
            'map_alias'     => $fields['catalog_alias']
        );
        
        $map_id = $this->sysDB->insert_map($map_array);
		
		$sql = "SELECT COUNT(*) FROM rs_catalog WHERE catalog_tree='".$this->map_parent."'";
		
		$catalog_position = $this->db->accept_count_select($sql) + 1;

        $fields['catalog_more'] = 0;
        
        if ($additional = $this->tools->get_object('additional'))
            $fields['catalog_more'] = $additional->add_value($fields['a_fields']);

		$what = array(
			'catalog_title'      => $fields['catalog_title'],
			'catalog_desc'       => $fields['catalog_desc'],
			'catalog_key'        => $fields['catalog_key'],
            'catalog_more'       => $fields['catalog_more'],
			'map_id'             => intval($map_id),
			'catalog_follow'     => ($fields['catalog_follow'] == 1) ? 1 : 0,
			'catalog_name'       => $fields['catalog_name'],
			'catalog_parent'     => 0,
			'catalog_link'       => $fields['catalog_link'],
			'catalog_tree'       => $this->map_parent,
			'catalog_position'   => $catalog_position
		);
		
		$catalog_id = $this->db->accept_insert($what, 'rs_catalog', 'catalog_id');
        
        // подключение модулей
        // END подключение модулей

		preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
		$referer = $referer[1];
		
		$this->tools->move_to($referer);		
	}
	
	/* CASE : BROWSE */
	
	function get_catalog($type)
	{
		$sql = "SELECT c.catalog_id as catalog_id, c.catalog_name as catalog_name, c.catalog_parent as catalog_parent,"
            ." c.catalog_position as catalog_position, m.map_alias as catalog_alias"
			." FROM rs_catalog c, rs_map m"
			." WHERE c.catalog_tree='".$this->map_parent."'"
            ." AND c.map_id=m.map_id"
			." ORDER BY c.catalog_position";
		
        $catalog = $this->db->accept_select($sql);
        
        $result['catalog'] = $catalog;
        $result['type']    = $type;
        	
		return $result;
	}
	
	/* CASE : EDIT */
	
	function get_edit_form($catalog_id)
	{
		$sql = "SELECT"
				." c.catalog_id as catalog_id, c.catalog_title as catalog_title, c.catalog_desc as catalog_desc,"
				." c.catalog_key as catalog_key, c.catalog_name as catalog_name, c.catalog_link as catalog_link,"
				." m.map_alias as catalog_alias, c.catalog_follow as catalog_follow"
			
			." FROM rs_catalog c, rs_map m"
			
			." WHERE"
				." m.map_id=c.map_id"
				." AND catalog_id='".$catalog_id."'";
			
		return $this->db->accept_select($sql);
	}
	
	function edit_catalog($fields)
	{
		$this->check_catalog($fields);
		
		if ($fields['catalog_alias'] != $fields['catalog_db_alias'])
			$fields['catalog_alias'] = $this->sysDB->check_take_alias($fields['catalog_alias'], $fields['map_parent']);

        if ($additional = $this->tools->get_object('additional'))
            $additional->edit_value($fields['a_fields'], $fields['catalog_id']);

		$this->udate_catalog($fields);

        $map_array = array(
            'map_id'            => $fields['map_id'],
            'map_alias'         => $fields['catalog_alias'],
            'map_name'          => $fields['catalog_name']
        );

        $this->sysDB->update_map($map_array);
		
		preg_match("/^(http:\/\/.*?\/admin\/.*?\/).*?$/", $_SERVER['HTTP_REFERER'], $referer);
		$referer = $referer[1];

		$this->tools->move_to($referer);
	}
	
	function udate_catalog($fields)
	{
		$what = array(
			'catalog_title'    => $fields['catalog_title'],
			'catalog_follow'   => ($fields['catalog_follow'] == 1) ? 1 : 0,
			'catalog_desc'     => $fields['catalog_desc'],
			'catalog_key'      => $fields['catalog_key'],
			'catalog_name'     => $fields['catalog_name'],
			'catalog_link'     => $fields['catalog_link']
		);
	
		$this->db->accept_update($what, 'rs_catalog', "catalog_id='".$fields['catalog_id']."'");
	}
	
	function check_catalog(&$fields)
	{
		$sql = "SELECT c.catalog_id as catalog_id, m.map_alias as catalog_alias, m.map_id as map_id,"
			." m.map_parent as map_parent"
			." FROM rs_catalog c, rs_map m"
			." WHERE"
			." catalog_id='".$fields['catalog_id']."'"
			." AND m.map_id=c.map_id";
			
		if (!$catalog = $this->db->accept_select($sql))
			return FALSE;
			
		$fields['catalog_id']		= $catalog[0]['catalog_id'];
		$fields['catalog_db_alias']	= $catalog[0]['catalog_alias'];
		$fields['map_id']           = $catalog[0]['map_id'];
		$fields['map_parent'] 		= $catalog[0]['map_parent'];
		
		return TRUE;
	}
}
?>