<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class fields_additional extends core
{
	/*инициализация объектов для работы данного класса*/
	public function fields_additional($value)
	{
		$this->core();

        $this->typeAlias    = $value['type'];
        $this->type         = str_replace('-', '_', $value['type']);       
        $this->suffix_table = $value['suffix'];
	}

	/* CASE : POSITION */
	
	public function change_position($field_id, $step)
	{
		$sql = "SELECT field_position, group_id FROM rs_fields WHERE field_id='".$field_id."'";
		
		if (!$position = $this->db->accept_select($sql))
			return FALSE;
		
		$old_position = $position[0]['field_position'];
			
		if ($step == 'down')
			$new_position = $position[0]['field_position'] + 1;
			
		if ($step == 'up')
			$new_position = $position[0]['field_position'] - 1;
			
		$sql = "SELECT field_id"
			." FROM rs_fields"
			." WHERE field_position='".$new_position."'"
			." AND group_id='".$position[0]['group_id']."'";
		
		if (!$row_id = $this->db->accept_select($sql))
			return FALSE;
		
		$this->db->accept_update(array('field_position' => $new_position), 'rs_fields', 'field_id=\''.$field_id.'\'');
		$this->db->accept_update(array('field_position' => $old_position), 'rs_fields', 'field_id=\''.$row_id[0]['field_id'].'\'');
		
		exit;
	}

    /* CASE : BROWSE */
    public function show_all_fields($group_id)
    {
        $sql = "SELECT * FROM rs_fields WHERE group_id='".$group_id."' ORDER BY field_position";
        
        $result['fields'] = array();
        
        if ($a_fields = $this->db->accept_select($sql))
        {
            foreach ($a_fields as $key => $field)
            {
                switch ($field['field_type'])
                {
                    case 0:
                        $a_fields[$key]['field_type_name'] = 'varchar';
                        break;
                    case 1:
                        $a_fields[$key]['field_type_name'] = 'int';
                        break;
                    case 2:
                        $a_fields[$key]['field_type_name'] = 'float';
                        break;
                    case 3:
                        $a_fields[$key]['field_type_name'] = 'decimal';
                        break;
                    case 4:
                        $a_fields[$key]['field_type_name'] = 'text';
                        break;
                    case 5:
                        $a_fields[$key]['field_type_name'] = 'option';
                        break;
                    case 6:
                        $a_fields[$key]['field_type_name'] = 'picture';
                        break;
                    case 7:
                        $a_fields[$key]['field_type_name'] = 'datetime';
                        break;
                    case 8:
                        $a_fields[$key]['field_type_name'] = 'html';
                        break;
                }
            }
            
            $result['fields'] = $a_fields;
        }
        
        $result['group_id'] = $group_id;
            
        return $result;
    }
    
    /* CASE : ADD */
    public function show_add_form($fields)
    {
        return $fields;
    }
    
    public function add_field($fields)
    {
        $sql = "SELECT * FROM rs_fields_group WHERE group_id='".$fields['group_id']."'";
        
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
        
        $group = $group[0];
        
        $sql = "SELECT * FROM rs_fields WHERE group_id='".$fields['group_id']."' AND field_alias='".$fields['alias']."'";
        
        if ($alias = $this->db->accept_select($sql))
            return FALSE;
        
        $sql = "SELECT COUNT(*) FROM rs_fields WHERE group_id='".$fields['group_id']."'";
        
        $field_position = $this->db->accept_count_select($sql);
        $field_position = $field_position + 1;
        
        $what = array(
            'field_name'          => $fields['field_name'],
            'field_alias'         => $fields['field_alias'],
            'field_type'          => $fields['field_type'],
            'group_id'            => $fields['group_id'],
            'field_position'      => $field_position
        );

        $this->db->accept_insert($what, 'rs_fields');
        
        $type = $this->get_type_field($fields['field_type']);
        
        $this->db->clear();
        $this->db->set_suffix_table($this->suffix_table);
        $this->db->set_type_field('field_'.$fields['field_alias'], $type['default'], $type['type']);
        $this->db->accept_add_field(str_replace('-', '_', $group['group_alias']));

        $this->tools->move_to('/admin/'.$this->typeAlias.'/fields/?group_id='.$fields['group_id']);
    }
    
    /* CASE : EDIT */
    
    public function show_edit_form($fields)
    {
        $sql = "SELECT * FROM rs_fields WHERE field_id='".$fields['field_id']."'";
        
        if (count($fields) == 2)
        {
            if ($a_fields = $this->db->accept_select($sql))
                $result = $a_fields[0];
        }
        else
            $result = $fields;
        
        return $result;
    }
    
    public function edit_field($fields)
    {
        //выводим всю информацию о поле
        $sql = "SELECT * FROM rs_fields WHERE field_id='".$fields['field_id']."'";
        
        if (!$a_fields = $this->db->accept_select($sql))
            return FALSE;

        $a_fields = $a_fields[0];
        
        //проверяем алиас
        if ($a_fields['field_alias'] != $fields['field_alias'])
        {
            $sql = "SELECT * FROM rs_fields WHERE group_id='".$fields['group_id']."' AND field_alias='".$fields['field_alias']."'";
            
            if ($alias = $this->db->accept_select($sql))
                return FALSE;
        }
        
        //обновляем инфу о поле в таблице rs_fields
        $what = array(
            'field_name'     => $fields['field_name'],
            'field_alias'    => $fields['field_alias'],
            'field_type'     => $fields['field_type']
        );
        
        $this->db->accept_update($what, 'rs_fields', "field_id='".$fields['field_id']."'");
        
        //определяем алиас группы полей
        $sql = "SELECT group_alias FROM rs_fields_group WHERE group_id='".$fields['group_id']."'";
        
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
        
        $group = $group[0];
        
        //определяем новый тип поля и его значение по дефолту
        $type = $this->get_type_field($fields['field_type']);
        
        //обновляем колонку в таблице
        $this->db->clear();
        $this->db->set_suffix_table($this->suffix_table);
        $this->db->set_type_field('field_'.$fields['field_alias'], $type['default'], $type['type']);
        $this->db->accept_edit_field((str_replace('-', '_', $group['group_alias'])), 'field_'.$a_fields['field_alias']);
        
        $this->tools->move_to('/admin/'.$this->typeAlias.'/fields/?group_id='.$fields['group_id']);
    }

    /* CASE : DELETE */
    
    public function delete_field($field_id)
    {
        //выводим всю инфу о поле
        $sql = "SELECT * FROM rs_fields WHERE field_id='".$field_id."'";
        if (!$field = $this->db->accept_select($sql))
            die();
        
        $field = $field[0];
        
        //определяем алиас группы (опознаем таблицу в БД)
        $sql = "SELECT * FROM rs_fields_group WHERE group_id='".$field['group_id']."'";
        if (!$group = $this->db->accept_select($sql))
            die();
        
        $group = $group[0];

        //определяем новый тип поля и его значение по дефолту
        $type = $this->get_type_field($field['field_type']);

        $this->db->clear();
        $this->db->set_suffix_table($this->suffix_table);
        $this->db->set_type_field('field_'.$field['field_alias'], $type['default'], $type['type']);
        $this->db->accept_delete_field(str_replace('-', '_', $group['group_alias']));
        $this->db->accept_delete("DELETE FROM rs_fields WHERE field_id='".$field_id."'");
        
        $sql = "SELECT * FROM rs_fields WHERE group_id='".$field['group_id']."' ORDER BY field_position";
        
        if ($positions = $this->db->accept_select($sql))
        {
            $new_position = 1;
            foreach ($positions as $position)
            {
                $this->db->accept_update(array('field_position' => $new_position), 'rs_fields', "field_id='".$position['field_id']."'");
                $new_position++;
            }
        }
        
        die();
    }

    /* РАЗНОЕ определяем тип поля */
    private function get_type_field($type_name)
    {
        switch($type_name)
        {
            case 0:
                $type    = 'varchar';
                $default = '';
                break;
            case 1:
                $type    = 'int';
                $default = '0';
                break;
            case 2:
                $type    = 'float';
                $default = '0.00';
                break;
            case 3:
                $type    = 'decimal';
                $default = '0.00';
                break;
            case 4:
                $type    = 'text';
                $default = '';
                break;
            case 5:
                $type    = 'int';
                $default = '0';
                break;
            case 6:
                $type    = 'varchar';
                $default = '';
                break;
            case 7:
                $type    = 'datetime';
                $default = '0000-00-00 00:00:00';
                break;
            case 8:
                $type    = 'text';
                $default = '';
                break;
        }
        
        $result['type'] = $type;
        $result['default'] = $default;
        
        return $result;
    }
}
?>