<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class additional extends core
{
    /*инициализация объектов для работы данного класса*/
    public function additional($value)
    {
        $this->core();
        
        $this->suffix_table     = $value['suffix'];
        $this->row_name         = $value['modul'];
        $this->type             = str_replace('-', '_', $value['type']);
        $this->typeAlias        = $value['type'];
        $this->field_picture    = array();
        
        $sql = "SELECT group_id FROM rs_fields_group WHERE group_alias='".$this->typeAlias."'";

        if ($group = $this->db->accept_select($sql))
            $this->group_id = $group[0]['group_id'];
    }
    
    public function clear_value($value)
    {
        $field_id = array();
        
        foreach ($value as $key => $field)
            $field_id[] = $this->tools->clear_int($key);
            
        $sql = "SELECT * FROM rs_fields WHERE field_id IN (".implode(',', $field_id).")";
        
        $fields = $this->db->accept_select($sql);
        
        foreach ($fields as $field)
        {
            $result[$field['field_id']] = array(
                'field_alias'   => $field['field_alias'],
                'field_type'    => $field['field_type']
            );
        }
        
        $fields = array();

        foreach ($value as $key => $field)
        {
            /*
             *  0 - varchar
             *  1 - int
             *  2 - float
             *  3 - decimal
             *  4 - text
             *  5 - option
             *  6 - picture
             *  7 - datetime
             *  8 - html
             */
            
            switch ($result[$key]['field_type'])
            {
                case 0:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_string($field);
                    break;
                case 1:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_int($field);
                    break;
                case 2:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_float($field);
                    break;
                case 3:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_float($field);
                    break;
                case 4:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_string($field);
                    break;
                case 5:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_int($field);
                    break;
                case 6:
                    switch($field) {
                        case 'edit':
                            break;
                        case 'add':
                            $fields['field_'.$result[$key]['field_alias']] = array(
                                'name'        =>    (isset($_FILES['file']['name'][$key]))     ? $_FILES['file']['name'][$key]     : '',
                                'type'        =>    (isset($_FILES['file']['type'][$key]))     ? $_FILES['file']['type'][$key]     : '',
                                'tmp_name'    =>    (isset($_FILES['file']['tmp_name'][$key])) ? $_FILES['file']['tmp_name'][$key] : '',
                                'error'       =>    (isset($_FILES['file']['error'][$key]))    ? $_FILES['file']['error'][$key]    : '',
                                'size'        =>    (isset($_FILES['file']['size'][$key]))     ? $_FILES['file']['size'][$key]     : ''
                            );
                            break;
                        case 'update':
                            $fields['field_'.$result[$key]['field_alias']] = array(
                                'name'        =>    (isset($_FILES['file']['name'][$key]))     ? $_FILES['file']['name'][$key]     : '',
                                'type'        =>    (isset($_FILES['file']['type'][$key]))     ? $_FILES['file']['type'][$key]     : '',
                                'tmp_name'    =>    (isset($_FILES['file']['tmp_name'][$key])) ? $_FILES['file']['tmp_name'][$key] : '',
                                'error'       =>    (isset($_FILES['file']['error'][$key]))    ? $_FILES['file']['error'][$key]    : '',
                                'size'        =>    (isset($_FILES['file']['size'][$key]))     ? $_FILES['file']['size'][$key]     : ''
                            );
                            $this->field_picture[] = 'field_'.$result[$key]['field_alias'];
                            break;
                        case 'delete':
                            $fields['field_'.$result[$key]['field_alias']] = '';
                            $this->field_picture[] = 'field_'.$result[$key]['field_alias'];
                            break;
                    }
                    break;
                case 7:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_string($field);
                    break;
                case 8:
                    $fields['field_'.$result[$key]['field_alias']] = $this->tools->clear_html($field);
                    break;
            }
        }
        
        return $fields;
    }
    
    /* CASE : ADD */
    
    public function show_form($fields = array())
    {
        $sql = "SELECT * FROM rs_fields WHERE group_id='".$this->group_id."' ORDER BY field_position";
        
        if (!$a_fields = $this->db->accept_select($sql))
            return array();

        foreach ($a_fields as $key => $field)
        {
            if (isset($fields['a_fields']['field_'.$field['field_alias']]))
                if ($field['field_type'] != 6)
                    $a_fields[$key]['field_value'] = $fields['a_fields']['field_'.$field['field_alias']];
            
            if ($field['field_type'] == 5)
            {
                $sql = "SELECT * FROM rs_option WHERE field_id='".$field['field_id']."'";
                
                if ($option = $this->db->accept_select($sql))
                    $a_fields[$key]['option'] = $option;
            }
        }
        
        $result['fields']   = $a_fields;
        $result['group_id'] = $this->group_id;

        return $result;
    }
    
    public function add_value($fields)
    {
        $sql = "SELECT group_alias FROM rs_fields_group WHERE group_id='".$fields['group_id']."'";
        
        $group = $this->db->accept_select($sql);
        $group = $group[0];
        
        unset($fields['group_id']);
        
        $what = array();
        
        foreach ($fields as $field => $value)
            $what[$field] = (!is_array($value)) ? $value : $this->add_photo($value);
        
        return $this->db->accept_insert($what, 'rs_'.(str_replace('-', '_', $group['group_alias'])).'_'.$this->suffix_table, 'group_id');
    }
    
    // добавление изображение в папку с content/files/
    private function add_photo($photo)
    {        
        if (empty($photo))
            return '';
        
        $formats_array = array(
            'image/jpeg',
            'image/gif',
            'image/png',
            'image/bmp'
        );

        if (!in_array($photo['type'], $formats_array))
            return '';
            
        $this->get_expansion($photo['type']);
        
        //$name = basename($this->tools->get_translit($photo['name']), $this->expansion);
        $name = preg_replace('/(.*?)\.[a-z]{3,4}$/', '$1', $this->tools->get_translit($photo['name']));
        
        if (mb_strlen($name) >= 32)
            return '';
            
        if ($photo['size'] > 6*1024*1024)
            return '';
        
        $name = $this->check_name(trim($name), 'files');

        copy($photo['tmp_name'], "content/files/".$name.$this->expansion);
        
        $path = 'content/files/'.$name.$this->expansion;
        
        return $path;
    }
    
    private function get_expansion($type)
    {
        $this->expansion = '';
        
        switch($type)
        {
            case 'image/jpeg':
                $this->expansion = '.jpg';
                break;
            case 'image/gif':
                $this->expansion = '.gif';
                break;
            case 'image/png':
                $this->expansion = '.png';
                break;
            case 'image/bmp':
                $this->expansion = '.bmp';
                break;
        }        
    }
    
    private function check_name($name, $folder, $sel = '')
    {
        if (file_exists("content/".$folder."/".$name.$sel.$this->expansion))
        {
            if ($sel == '')
                $sel = 0;
            
            $sel++;
            
            $result = $this->check_name($name, $folder, $sel);
        }
        else
            $result = $name.$sel;
            
        return $result;
    }
    
    /* CASE : EDIT */
    public function show_form_edit($row_id, $fields = array())
    {
        /* определяем тип для опознания таблицы с доп полями, и строчку со значениями доп полей */

        $sql = "SELECT"
                ." ".$this->row_name."_more"
            ." FROM"
                ." rs_".$this->row_name
            ." WHERE ".$this->row_name."_id='".$row_id."'";

        if(!$addition_db = $this->db->accept_select($sql))
            return array();
            
        $addition_db = $addition_db[0];

        /* Выводим значение доп. полей */
        
        $sql = "SELECT * FROM rs_".$this->type."_".$this->suffix_table." WHERE group_id='".$addition_db[$this->row_name.'_more']."'";
        
        if(!$fields_value = $this->db->accept_select($sql))
            return array();

        /* выводим ддоплнительные поля */
        
        $sql = "SELECT * FROM rs_fields WHERE group_id='".$this->group_id."' ORDER BY field_position";
        
        if (!$a_fields = $this->db->accept_select($sql))
            return array();
        
        foreach ($a_fields as $key => $field)
        {
            $a_fields[$key]['field_value'] = (isset($fields['a_fields']['field_'.$field['field_alias']])) ? $fields['a_fields']['field_'.$field['field_alias']] : $fields_value[0]['field_'.$field['field_alias']];
            
            if ($field['field_type'] == 5)
            {
                $sql = "SELECT * FROM rs_option WHERE field_id='".$field['field_id']."'";
                
                if ($option = $this->db->accept_select($sql))
                    $a_fields[$key]['option'] = $option;
            }
        }
            
        $result['fields']   = $a_fields;
        $result['group_id'] = $this->group_id;
        
        return $result;
    }
    
    public function edit_value($fields, $row_id)
    {
        /* Вывод алиасов полей, для создания массива для обновления записи */
        
        $sql = "SELECT group_alias FROM rs_fields_group WHERE group_id='".$fields['group_id']."'";
        
        $group = $this->db->accept_select($sql);
        $group = $group[0];
        
        unset($fields['group_id']);
        
        /* Вывод id строчки в таблице дополнительных полей */
        
        $sql = "SELECT ".$this->row_name."_more FROM rs_".$this->row_name." WHERE ".$this->row_name."_id='".$row_id."'";

        if (!$more = $this->db->accept_select($sql))
            return FALSE;

        $more = $more[0];
        
        $what = array();
        
        if (!empty($this->field_picture))
            $this->delete_photo($group['group_alias'], $more[$this->row_name.'_more']);
        
        foreach ($fields as $field => $value)
            $what[$field] = (!is_array($value)) ? $value : $this->add_photo($value);
        
        if (!empty($what))
            $this->db->accept_update($what, 'rs_'.(str_replace('-', '_', $group['group_alias'])).'_'.$this->suffix_table, "group_id='".$more[$this->row_name.'_more']."'");        
    }
    
    private function delete_photo($alias, $group_id)
    {
        foreach ($this->field_picture as $field)
        {
            $sql = "SELECT ".$field." as path FROM rs_".(str_replace('-', '_', $alias))."_".$this->suffix_table." WHERE group_id='".$group_id."'";
            
            if($path = $this->db->accept_select($sql))
                if (file_exists($path[0]['path']))
                    unlink($path[0]['path']);
        }
    }

    /* CASE : DELETE */
    
    public function delete_value($row_id)
    {
        $sql = "SELECT"
                ." ".$this->row_name."_more"
            ." FROM"
                ." rs_".$this->row_name
            ." WHERE"
            ." ".$this->row_name."_id='".$row_id."'";

        if (!$more = $this->db->accept_select($sql))
            return FALSE;

        $more = $more[0];
        
        // поиск полей с типом 6 (изображения)
        $sql = ""
            ."SELECT"
                ." f.field_alias as field_alias, f.field_type as field_type"
            ." FROM"
                ." rs_fields_group g, rs_fields f"
            ." WHERE 1=1"
                ." AND g.group_alias = '".$this->typeAlias."'"
                ." AND f.group_id = g.group_id";
            
        if (!$fields = $this->db->accept_select($sql))
            return FALSE;
        
        foreach($fields as $field)
            if ($field['field_type'] == 6)
                $this->field_picture[] = 'field_'.$field['field_alias'];
        
        // если найдены такие поля, то удаляем изображения
        if (!empty($this->field_picture))
            $this->delete_photo($this->type, $more[$this->row_name.'_more']);

        // удаляем запись
        $sql = "DELETE FROM rs_".$this->type."_".$this->suffix_table." WHERE group_id='".$more[$this->row_name.'_more']."'";
        
        $this->db->accept_delete($sql);
    }
}
?>