<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class notice extends core
{
    /*инициализация объектов для работы данного класса*/
    function notice()
    {
        $this->core();
    }
    
    /* CASE : BROWSE */
    
    /* получаем все шаблоны */
    function get_notice()
    {
        $sql = "SELECT * FROM rs_notice";
        
        if (!$notices = $this->db->accept_select($sql))
            return array();
            
        return $notices;
    }
    
    /* CASE : ADD */
    
    function add_notice(&$fields)
    {
        // проверка пустое ли имя
        if (empty($fields['notice_name']))
        {
            $fields['error'][0] = "Пустое поле";
            return FALSE;
        }
        
        // проверка пустой ил псевдоним
        if (empty($fields['notice_alias']))
        {
            $fields['error'][1] = "Пустое поле";
            return FALSE;
        }        
        
        // проверка уникальности псевдонима
        $sql = "SELECT * FROM rs_notice WHERE notice_alias='".$fields['notice_alias']."'";
        
        if ($notice = $this->db->accept_select($sql))
        {
            $fields['error'][2] = "Такой шаблон уже существует";
            return FALSE;
        }

        // проверка пустая ли тема
        if (empty($fields['notice_subject']))
        {
            $fields['error'][3] = "Пустое поле";
            return FALSE;
        } 

        // проверка пустое ли тело
        if (empty($fields['notice_message']))
        {
            $fields['error'][4] = "Пустое поле";
            return FALSE;
        }
        
        $what = array(
            'notice_name'       => $fields['notice_name'],
            'notice_alias'      => $fields['notice_alias'],
            'notice_subject'    => $fields['notice_subject'],
            'notice_message'    => $fields['notice_message']
        );

        $this->db->accept_insert($what, 'rs_notice');

        $this->tools->move_to('/admin/notice/');
    }
    
    /* CASE : EDIT */
    
    function show_edit_form($notice_id)
    {
        $sql = "SELECT * FROM rs_notice WHERE notice_id='".$notice_id."'";
        
        if (!$notices = $this->db->accept_select($sql))
            return array();
            
        return $notices[0];
    }
    
    function edit_notice(&$fields)
    {
        // проверяем есть ли редактируемый шаблон в БД
        $sql = "SELECT * FROM rs_notice WHERE notice_id='".$fields['notice_id']."'";
        
        if (!$notice = $this->db->accept_select($sql))
        {
            $fields['error'][5] = "Системная ошибка";
            return FALSE;            
        }
        
        // проверка пустое ли имя
        if (empty($fields['notice_name']))
        {
            $fields['error'][0] = "Пустое поле";
            return FALSE;
        }

        // проверка пустой ил псевдоним
        if (empty($fields['notice_alias']))
        {
            $fields['error'][1] = "Пустое поле";
            return FALSE;
        }        
        
        // проверка уникальности псевдонима
        if ($notice[0]['notice_alias'] != $fields['notice_alias'])
        {
            $sql = "SELECT * FROM rs_notice WHERE notice_alias='".$fields['notice_alias']."'";
            
            if ($notice = $this->db->accept_select($sql))
            {
                $fields['error'][2] = "Такой шаблон уже существует";
                return FALSE;
            }
        }
        
        // проверка пустая ли тема
        if (empty($fields['notice_subject']))
        {
            $fields['error'][3] = "Пустое поле";
            return FALSE;
        } 

        // проверка пустое ли тело
        if (empty($fields['notice_message']))
        {
            $fields['error'][4] = "Пустое поле";
            return FALSE;
        }
        
        $what = array(
            'notice_name'       => $fields['notice_name'],
            'notice_alias'      => $fields['notice_alias'],
            'notice_subject'    => $fields['notice_subject'],
            'notice_message'    => $fields['notice_message']
        );

        $this->db->accept_update($what, 'rs_notice', "notice_id='".$fields['notice_id']."'");

        $this->tools->move_to('/admin/notice/');
    }
    
    /* CASE : DELETE */
    
    function delete_notice($notice_id)
    {
        $sql = "SELECT * FROM rs_notice WHERE notice_id='".$notice_id."'";

        if (!$notice = $this->db->accept_select($sql))
            die('no notice');
            
        $sql = "DELETE FROM rs_notice WHERE notice_id='".$notice_id."'";
        
        $this->db->accept_delete($sql);
    }
}
?>