<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class paramValue extends core
{
    /*инициализация объектов для работы данного класса*/
    public function paramValue($value)
    {
        $this->core();
        
        // проверки на существование групп
        $this->group_id     = (isset($GLOBALS['groupid']))    ? $this->tools->clear_int($GLOBALS['groupid'])    : '';
        $this->subgroup_id  = (isset($GLOBALS['subgroupid'])) ? $this->tools->clear_int($GLOBALS['subgroupid']) : '';
        $this->param_id     = (isset($GLOBALS['paramid']))    ? $this->tools->clear_int($GLOBALS['paramid'])    : '';

        // проверяем группу
        if ($this->group_id !== '')
            if (!$this->checkGroup($this->group_id))
                $this->tools->not_found();
        
        // проверяем вложенную группу
        if ($this->subgroup_id !== '')
            if (!$this->checkGroup($this->subgroup_id))
                $this->tools->not_found();
                
        // проверяем параметр
        if ($this->param_id !== '')
            if (!$this->checkParam($this->param_id))
                $this->tools->not_found();
    }
        
    /* CASE : BROWSE */
    
    public function getValue()
    {
        $sql = ""
            ."SELECT"
                ." value.value_id         AS value_id,"
                ." value.value_name       AS value_name,"
                ." value.value_position   AS value_position,"
                ." value.param_id         AS param_id"
            ." FROM"
                ." rs_param_value value"
            ." WHERE"
                ." value.param_id  = '".$this->param_id."'"
            ." ORDER BY value.value_position"
        ;

        if (!$values = $this->db->accept_select($sql))
            return array();
        
        $this->getCaptionName();

        return $values;
    } 
    
    /* CASE : ADD */
    
    public function addValue(&$fields)
    {
        // проверяем имя значения
        if (empty($fields['value_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;            
        }
        
        // подсчитываем позицию
        $sql = "SELECT COUNT(*) FROM rs_param_value WHERE param_id = '".$this->param_id."'";
        
        $value_position  = $this->db->accept_count_select($sql) + 1;
        
        $what = array(
            'value_name'        => $fields['value_name'],
            'param_id'          => $this->param_id,
            'value_position'    => $value_position
        );

        $this->db->accept_insert($what, 'rs_param_value');

        $this->tools->move_to('/admin/parameter/'.$this->group_id.'/'.$this->subgroup_id.'/'.$this->param_id.'/');
    }
    
    /* CASE : EDIT */
    
    public function showForm($value_id, $fields)
    {
        if (!empty($fields))
            return $fields;

        $sql = ""
            ."SELECT"
                ." value.value_id     AS value_id,"
                ." value.value_name   AS value_name"
            ." FROM"
                ." rs_param_value value"
            ." WHERE"
                ."     value.value_id = '".$value_id."'"
                ." AND value.param_id = '".$this->param_id."'"
        ;
        
        if (!$value = $this->db->accept_select($sql))
            return array();
        
        return $value[0];            
    }
    
    public function editValue(&$fields)
    {
        // проверка имени
        if (empty($fields['value_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;
        }

        // проверяем id значения
        $sql = ""
            ."SELECT"        
                ." value.value_id AS value_id"
            ." FROM"
                ." rs_param_value value"
            ." WHERE"
                ." value.param_id         = '".$this->param_id."'"
                ." AND value.value_id     = '".$fields['value_id']."'"
        ;
        
        if (!$value = $this->db->accept_select($sql)) {
            $fields['error'] = 'id.empty';
            return FALSE;
        }
        
        // обновляем запись
        $what = array(
            'value_name'       => $fields['value_name']
        );

        $this->db->accept_update($what, 'rs_param_value', "value_id='".$fields['value_id']."'");

        $this->tools->move_to('/admin/parameter/'.$this->group_id.'/'.$this->subgroup_id.'/'.$this->param_id.'/');
    }

    /* CASE : DELETE */
    
    public function deleteValue($value_id)
    {
        $this->db->accept_delete("DELETE FROM rs_param_value WHERE value_id='".$value_id."' AND param_id='".$this->param_id."'");
        
        if (!$this->update_position())
            die('ERROR UPDATE POSITION');
        
        die('OK');
    }
    

    /* CASE : POSITION */
    
    function change_position($value_id, $step)
    {
        $sql = ""
            ."SELECT"
                ." value_position"
            ." FROM"
                ." rs_param_value"
            ." WHERE"
                ."     value_id        = '".$value_id."'"
                ." AND param_id        = '".$this->param_id."'"
        ;
        
        if (!$position = $this->db->accept_select($sql))
            return FALSE;
        
        $old_position = $position[0]['value_position'];
            
        if ($step == 'down')
            $new_position = $position[0]['value_position'] + 1;
            
        if ($step == 'up')
            $new_position = $position[0]['value_position'] - 1;
            
        $sql = ""
            ."SELECT"
                ." value_id"
            ." FROM"
                ." rs_param_value"
            ." WHERE"
                ."     value_position  = '".$new_position."'"
                ." AND param_id        = '".$this->param_id."'"
        ;
        
        if (!$row_id = $this->db->accept_select($sql))
            return FALSE;
        
        $this->db->accept_update(array('value_position' => $new_position), 'rs_param_value', 'value_id=\''.$value_id.'\'');
        $this->db->accept_update(array('value_position' => $old_position), 'rs_param_value', 'value_id=\''.$row_id[0]['value_id'].'\'');
        
        die();
    }
    
    /* РАЗНОЕ */
    
    private function update_position()
    {
        // выводим группы по паренту
        $sql = ""
            ."SELECT"
                ." value_id"
            ." FROM"
                ." rs_param_value"
            ." WHERE"
                ." param_id = '".$this->param_id."'"
        ;
        
        // обновляем позицию
        if (!$position = $this->db->accept_select($sql))
            return FALSE;


        $new_position = 1;
        foreach ($position as $value)
        {
            $what   = array('value_position' => $new_position);
            $where  = 'value_id=\''.$value['value_id'].'\'';
            
            $this->db->accept_update($what, 'rs_param_value', $where);
            
            $new_position++;
        }
        
        return TRUE;
    }
    
    private function getCaptionName()
    {
        
        if ($this->group_id !== '') {
            
            $sql = "SELECT group_name FROM rs_param_group WHERE group_id = '".$this->group_id."'";
            
            if ($group_name = $this->db->accept_select($sql))
                $this->tools->get_caption($group_name[0]['group_name'], 'groupid');
        }
        
        if ($this->subgroup_id !== '') {
            
            $sql = "SELECT group_name FROM rs_param_group WHERE group_id = '".$this->subgroup_id."'";
            
            if ($group_name = $this->db->accept_select($sql))
                $this->tools->get_caption($group_name[0]['group_name'], 'subgroupid');
        }
        
        if ($this->param_id !== '') {
            
            $sql = "SELECT param_name FROM rs_param WHERE param_id = '".$this->param_id."'";
            
            if ($param_name = $this->db->accept_select($sql))
                $this->tools->get_caption($param_name[0]['param_name'], 'paramid');
        }
    }
    
    private function checkGroup($group_id)
    {
        $sql = ""
            ."SELECT"
                ." group_id"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ."     group_id = '".$group_id."'"
        ;
        
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
            
        return TRUE;
    }
    
    private function checkParam($param_id)
    {
        $sql = ""
            ."SELECT"
                ." param_id"
            ." FROM"
                ." rs_param"
            ." WHERE"
                ." param_id = '".$param_id."'"
        ;
        
        if (!$param = $this->db->accept_select($sql))
            return FALSE;
            
        return TRUE;
    }
}
?>