<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class rss extends core
{
    /*инициализация объектов для работы данного класса*/
    function rss($value)
    {
        $this->core();
        $this->array  = $value['array'];
        $this->rc     = $value['rc'];
        $this->meta   = $value['meta'];
        
        if (!is_array($this->array))
            $this->array = array($this->array);
            
        foreach ($this->array as $key => $array)
            $this->array[$key] = "'".$array."'";
    }
    
    /* CASE : BROWSE */
    
    function get_info_rss()
    {
        $result = array();
        
        if (!file_exists("./rss.xml"))
            return $result;

        
        $result['name']  = 'rss.xml';
        $result['size']  = $this->get_size();
        $result['time']  = $this->get_time();
        
        return $result;
    }

    // определяем время генерации
    function get_time()
    {
        return $this->tools->change_date(date('Y-m-d H:i:s', filemtime("./rss.xml")));
    }

    // определяем размер карты
    function get_size()
    {
        $size = filesize("./rss.xml");

        $size_txt = array(' байт',' кбайт',' мбайт');

        for($i=0;$i<3;$i++)
        {
            if ($size >= 1024)
            {
                $size = $size/1024;
                $size = round($size, 2);
            }
            else
            {
                $size = $size.$size_txt[$i];
                break;
            }
        }
        
        return $size;
    }
    
    /* CASE : UPDATE */
    
    function update_rss()
    {
        $sql = ""
            ."SELECT"
                ." c.catalog_id as catalog_id,"
                ." c.content_announce as content_announce,"
                ." c.content_title as content_title,"
                ." c.content_id as content_id,"
                ." c.content_publication as content_publication,"
                ." m.map_alias as alias,"
                ." m.map_parent as map_parent"
            ." FROM"
                ." rs_content c,"
                ." rs_map m"
            ." WHERE 1=1"
                ." AND c.map_id = m.map_id"
                ." AND c.content_rss = '1'"
                ." AND c.content_type IN (".implode(',', $this->array).")"
                ." ORDER BY c.content_publication DESC"
                ." LIMIT ".$this->rc." OFFSET 0";


        if (!$urls = $this->db->accept_select($sql))
            $this->tools->move_to('/admin/rss/');

        foreach ($urls as $key => $value)
        {
            if (!preg_match("/^.*?\.html$/", $urls[$key]['alias']))
                $urls[$key]['alias']     = $urls[$key]['alias'].'/';

            if (!$this->get_catalog_tree($value['catalog_id']))
                $this->root = $value['map_parent'];
            
            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $this->root, $path);
            
            $urls[$key]['content_publication']   = date("D, d M Y H:i:s", $this->get_second($urls[$key]['content_publication']));
            $urls[$key]['link']                  = $GLOBALS['rssite']['cfg']['server_root']
                                                   .( (!empty($path)) ? implode('/', array_reverse($path)).'/'.$urls[$key]['alias'] : $urls[$key]['alias'] );
        }
        
        $sql = "SELECT * FROM rs_meta WHERE meta_id = '".$this->meta."'";
        
        if (!$meta = $this->db->accept_select($sql))
            $this->tools->move_to('/admin/rss/');
            
        $meta = $meta[0];

        $xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<rss version=\"2.0\">\n\t<channel>\n\t\t<title>".$meta['meta_title']."</title>\n\t\t<link>".$GLOBALS['rssite']['cfg']['server_root']."</link>\n\t\t<description>".$meta['meta_desc']."</description>\n\t\t<language>ru-ru</language>\n";

        foreach ($urls as $url)
            $xml .= "\t\t<item>\n\t\t\t<title>".$url['content_title']."</title>\n\t\t\t<link>".$url['link']."</link>\n\t\t\t<description><![CDATA[".$url['content_announce']."]]></description>\n\t\t\t<pubDate>".$url['content_publication']."</pubDate>\n\t\t</item>\n";
        
        $xml .= "\t</channel>\n</rss>";

        $rssFILE = fopen("./rss.xml", "w+");
        fwrite($rssFILE, $xml);
        fclose($rssFILE);
        
        $this->tools->move_to('/admin/rss/');
    }

    // переводим время из формата 0000-00-00 00:00:00 в секунды
    function get_second($t)
    {
        $t     = explode(" ", $t);
        $ymd   = explode("-", $t[0]);
        $his   = explode(":", $t[1]);
        
        return mktime ($his[0], $his[1], $his[2], $ymd[1], $ymd[2], $ymd[0]);
    }

    // определяем узел каталога
    function get_catalog_tree($catalog_id)
    {
        if (isset($this->root))
            unset($this->root);

        if (empty($GLOBALS['rssite']['cachecatalog']))
            return FALSE;

        foreach ($GLOBALS['rssite']['cachecatalog'] as $tree => $station)
        {
            foreach ($station as $key => $value)
                if ($value['id'] == $catalog_id)
                {
                    $this->root = $tree;
                    break;
                    break;
                }
        }
        
        if (!isset($this->root))
            return FALSE;

        return TRUE;
    }
    
    /* CASE : CLEAR */
    
    function rss_clear()
    {
        $rssFILE = fopen("./rss.xml", "w+");
        fwrite($rssFILE, '');
        fclose($rssFILE);
        
        $this->tools->move_to('/admin/rss/');
    }
}
?>