<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class content extends core
{
    function content($value)
    {
        $this->core();
        
        $this->type    = $value['type'];
        $this->suffix  = $value['suffix'];
    }
    
    function get_content($content_id)
    {
        $access = $GLOBALS['rssite']['user']['user_access'];

        $this->get_additional_fields();
        
        $sql = "SELECT"
            ." c.content_id as content_id, c.map_id as map_id, m.map_alias as content_alias, m.map_parent as map_parent, c.content_num_comm as content_comm,"
            ." c.content_title as content_title, c.content_desc as content_desc, c.content_key as content_key,"
            ." c.content_announce as content_announce, c.content_text as content_text, c.content_publication as content_publication,"
            ." c.catalog_id as catalog_id, u.user_id as user_id, u.user_name as user_name, u.user_login as user_login, "
            ." u.user_status as user_status, u.user_access as user_access, c.content_view_comm as content_view_comm".$this->addSQL
        ." FROM"
            ." rs_content c, rs_map m, rs_user u".( (!empty($this->addSQL)) ? ", rs_".$this->type."_".$this->suffix." f" : '' )
        ." WHERE"
            ." c.content_type='".$this->type."'"
            ." AND c.map_id=m.map_id"
            ." AND c.user_id=u.user_id"
            .( ($access < 2) ? " AND c.content_mode_publication='1'" : '' )
            ." AND c.content_more=".( (!empty($this->addSQL)) ? "f.group_id" : "'0'" )
            ." AND c.content_id='".$content_id."'";

        if (!$post = $this->db->accept_select($sql))
            $this->tools->not_found();

        foreach($post as $key => $value)
        {
            $GLOBALS['rssite']['currentcatalog'] = $value['catalog_id'];
            
            $post[$key]['content_publication']   = $this->tools->change_date($value['content_publication']);
            
            $tree = '';
            
            if ($value['catalog_id'] != 0)
                foreach ($GLOBALS['rssite']['cachecatalog'] as $root => $stations)
                    foreach ($stations as $k => $station)
                        if ($station['id'] == $value['catalog_id'])
                        {
                            $tree         = $root;
                            $station_name = $station['name'];
                            $station_link = $station['link'];
                            break;
                            break;
                        }
                        
            if (empty($tree))
                $tree = $value['map_parent'];

            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $tree, $path);

            $post[$key]['catalog_link']  = (!empty($path)) ? implode('/', array_reverse($path)) : '';
            $post[$key]['catalog_name']  = (empty($station_link)) ? $station_name : '';
        }

        // выводим метатеги страницы
        $GLOBALS['rssite']['cfg']['meta']['two'] = array(
            'meta_title'        => $post[0]['content_title'],
            'meta_desc'         => $post[0]['content_desc'],
            'meta_key'          => $post[0]['content_key']
        );
        
        // если одно из доп полей является типом option то вытаскиваем имена опций
        if (!empty($this->option))
            $this->get_option($post);
        
        $post = array ('content'    => $post);
        
        $this->get_gallery($post);
        
        return $post;
    }
    
    // метод вывода имен опций
    function get_option(&$post)
    {
        $option_id = array();
        
        foreach ($this->option as $field)
            $option_id[] = "'".$post[0]['field_'.$field]."'";

        $sql = "SELECT option_value, option_id FROM rs_option WHERE option_id IN (".implode(',', $option_id).")";
        
        if (!$options = $this->db->accept_select($sql))
            return FALSE;
        
        foreach ($this->option as $field)
            foreach ($options as $option)
                if ($post[0]['field_'.$field] == $option['option_id'])
                    $post[0]['field_'.$field.'_name'] = $option['option_value'];
    }
    
    // метод поиска доп полей
    function get_additional_fields()
    {
        $this->option = array();
        
        // проверка на наличие дополнительных полей. $this->addSQL будет содержать дополнительную строку к SELECT запросу, или пустоту
        $sql = "SELECT"
                ." f.field_id as field_id, f.field_alias as field_alias, f.field_type as field_type"
            ." FROM rs_fields_group g LEFT JOIN rs_fields f ON g.group_id=f.group_id"
            ." WHERE 1=1"
                ." AND g.group_alias='".$this->type."'";
        
        $this->addSQL = array();
        
        if ($fields = $this->db->accept_select($sql))
            foreach ($fields as $field)
            {
                if ($field['field_type'] == 5)
                    $this->option[] = $field['field_alias'];
                
                $this->addSQL[] = ' f.field_'.$field['field_alias'].' as field_'.$field['field_alias'];
            }

        $this->addSQL = (!empty($this->addSQL)) ? ', '.implode(', ', $this->addSQL) : '';
    }
    
    // метод поиска галерей
    function get_gallery(&$post)
    {
        preg_match_all("/rs_gallery\[\'([0-9]+)\'\]/s", $post['content'][0]['content_text'], $gallerys);
        
        foreach ($gallerys[1] as $gallery)
        {
            $sql = "SELECT * FROM rs_gallery_files WHERE gallery_id = '".$gallery."'";
            
            if (!$galley_db = $this->db->accept_select($sql))
                continue;
            
            $post['gallery'][$gallery] = $galley_db;
            
            $post['content'][0]['content_text'] = preg_replace("/<p>rs_gallery\[\'[0-9]+\'\]<\/p>/s", "<div id='gallery_".$gallery."'></div>", $post['content'][0]['content_text'], 1);
        }
    }
}
?>