<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class lastcomm extends core
{
    function lastcomm($value)
    {
        $this->core();
        $this->limit    = $value['limit'];
        $this->length   = $value['length'];
    }

    /* CASE : BROWSE */
    
    /* получаем все комментарии */
    function get_comment()
    {
        if($cache = $this->cache->readerCACHE('lastcomm', $_GET['chpu_links'], 1*60*60, TRUE))
            return $cache;
        
        $sql = "SELECT"
            ." c.comment_id as comment_id, c.comment_author as comment_author, c.comment_site as comment_site, c.comment_email as comment_email,"
            ." c.comment_text as comment_text, c.comment_publication as comment_publication, cnt.catalog_id as catalog_id,"
            ." c.content_id as content_id, m.map_alias as content_alias, m.map_parent as map_parent"
        ." FROM rs_comment c, rs_content cnt, rs_map m"
        ." WHERE 1=1"
            ." AND c.content_id=cnt.content_id"
            ." AND cnt.map_id=m.map_id"
            ." AND c.comment_status > '0'"
            ." ORDER BY c.comment_publication DESC LIMIT ".$this->limit." OFFSET 0";
            
        if (!$comments = $this->db->accept_select($sql))
            return array();
            
        foreach($comments as $key => $comment)
            $comments[$key]['comment_email'] = md5($comment['comment_email']);

        $this->change_date($comments);
        $this->clear_text($comments);
        $this->get_dir($comments);
        
        $this->cache->writeCACHE('lastcomm', $_GET['chpu_links'], $comments, TRUE);
        
        return $comments;
    }

    function get_catalog_tree($catalog_id)
    {
        foreach($GLOBALS['rssite']['cachecatalog'] as $tree => $catalog_array)
            foreach ($catalog_array as $catalog)
                if ($catalog_id == $catalog['id'])
                    return $tree;
                    
        return FALSE;
    }

    function clear_text(&$comments)
    {
        foreach ($comments as $key => $comment)
        {
            $comment['comment_text'] = strip_tags($comment['comment_text']);
            
            if ($rs_bbcode = $this->tools->get_object('rs_bbcode'))
                $comment['comment_text'] = $rs_bbcode
                                             ->setText($comment['comment_text'])
                                             ->getText()
                                         ;

            $comment['comment_text'] = iconv('UTF-8','windows-1251', $comment['comment_text']);
            
            if (strlen($comment['comment_text']) > $this->length)
                $comment['comment_text'] = substr($comment['comment_text'], 0, $this->length)."...";
            
            $comment['comment_text'] = iconv('windows-1251', 'UTF-8', $comment['comment_text']);
            
            $comments[$key]['comment_text'] = $comment['comment_text'];
        }
    }
    
    /* заменяем даты на человекочитаемые */ 
    function change_date(&$comments)
    {
        foreach ($comments as $key => $comment)
            $comments[$key]['comment_publication'] = $this->tools->change_date($comment['comment_publication']);        
    }

    /* формируем ссылки на посты */
    function get_dir(&$comments)
    {
        foreach ($comments as $key => $comment)
        {
            $type = FALSE;

            if (!preg_match("/^.*?\.html$/", $comment['content_alias']))
                $type = TRUE;

            $comment['catalog_tree'] = $this->get_catalog_tree($comment['catalog_id']);
            
            if ($comment['catalog_tree'] === FALSE)
                $comment['catalog_tree'] = $comment['map_parent'];
                
            $path = array();
            $this->tools->get_parents_dir($comment['catalog_id'], $comment['catalog_tree'], $path);
            
            $comments[$key]['path'] = '/'
                .( (!empty($path)) ? implode('/', array_reverse($path)).'/' : '' )
                .$comment['content_alias'].( ($type === TRUE) ? '/' : '' )
                .'#comment_'.$comment['comment_id'];
        }
    }
}
?>